package com.lqkj.link.module.zone.service.impl;

import com.lqkj.link.module.zone.domain.LayerInfo;
import com.lqkj.link.module.zone.domain.TmpGeomInfo;
import com.lqkj.link.module.zone.domain.TmpLayerInfo;
import com.lqkj.link.module.zone.domain.TmpOneZoneGeomInfos;
import com.lqkj.link.module.zone.repository.LayerInfoRepository;
import com.lqkj.link.module.zone.repository.TmpLayerInfoRepository;
import com.lqkj.link.module.zone.service.TmpLayerInfoService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class TmpLayerInfoServiceImpl implements TmpLayerInfoService {
    private final TmpLayerInfoRepository tmpLayerInfoRepository;

    public TmpLayerInfoServiceImpl(TmpLayerInfoRepository tmpLayerInfoRepository) {
        this.tmpLayerInfoRepository = tmpLayerInfoRepository;
    }

    @Override
    public void saveTmpLayer(TmpOneZoneGeomInfos geomInfos) {
        if (geomInfos.getModifyLayerList() != null && geomInfos.getModifyLayerList().size() > 0) {
            for (TmpLayerInfo tmpLayerInfo : geomInfos.getModifyLayerList()) {
                tmpLayerInfo.setZoneId(geomInfos.getZoneId());
                tmpLayerInfo.setCreateTime(new Date());
            }
            tmpLayerInfoRepository.saveAll(geomInfos.getModifyLayerList());
        }

        // 删除图层
        if (geomInfos.getDeleteLayerList() != null && geomInfos.getDeleteLayerList().size() > 0)
            tmpLayerInfoRepository.deleteAllByIdInBatch(geomInfos.getDeleteLayerList());
    }

    @Override
    public List<TmpLayerInfo> findAll(Integer zoneId, Integer userId, Integer status) {
        return tmpLayerInfoRepository.findAllByParam(zoneId, userId, status);
    }
}
